import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.object.to-string";
import "core-js/modules/es7.object.values";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import "core-js/modules/es6.array.find-index";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";

/**
 * @authors Neo (lihe3@beisen.com)
 * @date    2017-04-20 10:14:49 
 * @version $Id$
 */
import React, { Component } from 'react';
import { getItalentApiUrl, taker, getUserInfo } from './utils'; // import './index.css';

var UserSelect =
/*#__PURE__*/
function (_Component) {
  _inherits(UserSelect, _Component);

  function UserSelect(p, t) {
    var _this;

    _classCallCheck(this, UserSelect);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(UserSelect).call(this, p, t));

    _this.sortData = function () {
      var state = _this.state;

      var _resultsTemp;

      _resultsTemp = state.results;
      var resIdArray = [];
      var resArray = [];

      for (var i = 0; i < _resultsTemp.length; i++) {
        if (!_resultsTemp[i]) continue;else if (resIdArray.indexOf(_resultsTemp[i].Id) == -1) {
          resIdArray.push(_resultsTemp[i].Id);
          resArray.push(_resultsTemp[i]);
        }
      }

      ;

      _this.setState({
        results: resArray
      });
    };

    _this.addResults = function (id, dataNow, pid, onSure) {
      if (isNaN(pid) && dataNow == 'departments') return;
      var results = _this.state.results;

      if (pid || pid == 0) {
        var index_dep_ADDRESULTS = _this.state[dataNow].findIndex(function (v) {
          return v.Id == pid;
        });

        var dep_users = _this.state[dataNow][index_dep_ADDRESULTS].childUser;
        var select_dep_users = dep_users.filter(function (v1) {
          return v1.Id == id;
        });
        results.push.apply(results, _toConsumableArray(select_dep_users));
      } else {
        var index_ADDRESULTS = _this.state[dataNow].findIndex(function (v) {
          return v.Id == id;
        });

        var value_ADDRESULTS = _this.state[dataNow][index_ADDRESULTS];

        if (dataNow == 'departments') {
          results.push(value_ADDRESULTS);
        } else {
          results.push(value_ADDRESULTS);
        }
      }

      _this.sortData();
    };

    _this.clearResults = function (isAll, id) {
      var results = _this.state.results;

      if (isAll) {
        _this.setState({
          results: []
        });
      } else {
        var newResults = results.filter(function (re, k) {
          return re.Id != id;
        });

        _this.setState({
          results: newResults
        });
      }
    };

    _this.closeComponent = function () {
      _this.setState({
        multi: false,
        results: [],
        searchs: []
      });
    };

    _this.setMulti = function () {
      _this.setState({
        multi: true
      });
    };

    _this.addAllUsers = function (dataNow) {
      var results = _this.state.results;
      results.push.apply(results, _toConsumableArray(_this.state[dataNow]));

      _this.sortData();
    };

    _this.state = {
      hidden: false,
      multi: false,
      usedusers: [],
      staffs: [],
      departments: [],
      results: [],
      searchs: [],
      isFetching: false,
      UserSelector: null
    };
    _this.tenantId = BSGlobal.tenantInfo.Id;
    _this.userId = BSGlobal.loginUserInfo.Id;
    _this.config = {
      singleSelect: false,
      // 单人选人，没有高级模式		
      TenantId: _this.tenantId,
      // 租户ID
      UserId: _this.userId,
      // 用户ID
      apiType: 'tita',
      // 接口产品 
      isUseInitial: true,
      // 是否使用内置接口
      onSure: p.onSure,
      // 精简模式下 返回点击的人 数据格式   高级模式下 确定回调 返回已选择的数组
      onClose: p.onClose // 高级模式下 取消回调 

    };
    _this.getUsedInfo = _this.getUsedInfo.bind(_assertThisInitialized(_this));
    _this.getSearchInfo = _this.getSearchInfo.bind(_assertThisInitialized(_this));
    _this.getDepartments = _this.getDepartments.bind(_assertThisInitialized(_this));
    _this.getStaff = _this.getStaff.bind(_assertThisInitialized(_this));
    _this.getDepInfo = _this.getDepInfo.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(UserSelect, [{
    key: "getDepartments",
    value: function () {
      var _getDepartments = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        var departmentsUrl, res;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                departmentsUrl = "".concat(getItalentApiUrl('department/All'));
                _context.next = 3;
                return taker(departmentsUrl);

              case 3:
                res = _context.sent;
                this.setState({
                  departments: res.Data
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getDepartments() {
        return _getDepartments.apply(this, arguments);
      }

      return getDepartments;
    }()
  }, {
    key: "getDepInfo",
    value: function () {
      var _getDepInfo = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee2(id) {
        var departments, depInfoUrl, res, users, index;
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                departments = this.state.departments;
                depInfoUrl = "".concat(getItalentApiUrl('department/DepartmentOfUser'), "?department_id=").concat(id);
                _context2.next = 4;
                return taker(depInfoUrl);

              case 4:
                res = _context2.sent;
                users = res.Data;
                index = departments.findIndex(function (de, k) {
                  return de.Id == id;
                });
                departments[index].childUser = users;
                this.setState({
                  departments: departments
                });

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getDepInfo(_x) {
        return _getDepInfo.apply(this, arguments);
      }

      return getDepInfo;
    }()
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      import(
      /* webpackChunkName: "userSelector" */
      "@beisen-platform/user-selector").then(function (UserSelector) {
        _this2.setState({
          UserSelector: UserSelector.default || UserSelector
        });
      });
    }
  }, {
    key: "getStaff",
    value: function () {
      var _getStaff = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee3() {
        var diffUrl, res, temp_GETSTAFF, i;
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                diffUrl = "".concat(getItalentApiUrl('org/GetMySubordinates'), "?lv=2&type=0");
                _context3.next = 3;
                return taker(diffUrl);

              case 3:
                res = _context3.sent;
                temp_GETSTAFF = [];

                for (i = 1; i < res.Data.length; i++) {
                  temp_GETSTAFF.push(res.Data[i]['User']);
                }

                this.setState({
                  staffs: temp_GETSTAFF
                });

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getStaff() {
        return _getStaff.apply(this, arguments);
      }

      return getStaff;
    }()
  }, {
    key: "getUsedInfo",
    value: function () {
      var _getUsedInfo = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee4() {
        var contactUrl, res;
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(this.props.type && this.props.type == 2)) {
                  _context4.next = 4;
                  break;
                }

                this.setState({
                  usedusers: []
                });
                _context4.next = 9;
                break;

              case 4:
                contactUrl = "".concat(getItalentApiUrl('Contact'));
                _context4.next = 7;
                return taker(contactUrl);

              case 7:
                res = _context4.sent;
                this.setState({
                  usedusers: Object.values(res.Data)
                });

              case 9:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getUsedInfo() {
        return _getUsedInfo.apply(this, arguments);
      }

      return getUsedInfo;
    }()
  }, {
    key: "getSearchInfo",
    value: function () {
      var _getSearchInfo = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee5(value, url) {
        var val, searchUrl, res, _searchUrl, _res;

        return _regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                // const searchUrl = `${getItalentApiUrl('user')}?filters=${value}`;
                // const res = await taker(searchUrl);
                // const val = res && res.Data && res.Data.SimpleUserModel?Object.values(res.Data.SimpleUserModel):[];
                // this.setState({searchs:val})
                // type是因为加人的时候，加人弹层做权限设置，搜索接口使用可以进行权限判断的组件
                val = [];

                if (!(this.props.type && this.props.type == 2)) {
                  _context5.next = 9;
                  break;
                }

                searchUrl = "".concat(getItalentApiUrl('proxy/GetUPaaSCoreGateway'), "?metaname=ProfileAuthority&funname=SearchStaffWithAuthority&bizUserId=").concat(getUserInfo().Id, "&keyword=").concat(value);
                _context5.next = 5;
                return taker(searchUrl);

              case 5:
                res = _context5.sent;
                val = res && res.OperationObject ? Object.values(res.OperationObject) : [];
                _context5.next = 14;
                break;

              case 9:
                _searchUrl = "".concat(getItalentApiUrl('user'), "?filters=").concat(value);
                _context5.next = 12;
                return taker(_searchUrl);

              case 12:
                _res = _context5.sent;
                val = _res && _res.Data && _res.Data.SimpleUserModel ? Object.values(_res.Data.SimpleUserModel) : [];

              case 14:
                this.setState({
                  searchs: val
                });

              case 15:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getSearchInfo(_x2, _x3) {
        return _getSearchInfo.apply(this, arguments);
      }

      return getSearchInfo;
    }()
  }, {
    key: "render",
    value: function render() {
      var UserSelector = this.state.UserSelector;
      if (!UserSelector) return null;
      return React.createElement("div", {
        className: "user-selector-wrap",
        onClick: function onClick(e) {
          e.stopPropagation();
          e.nativeEvent.stopImmediatePropagation();
        }
      }, React.createElement(UserSelector, _extends({
        searchPlaceholde: "",
        getDepartments: this.getDepartments,
        getDepInfo: this.getDepInfo,
        addResults: this.addResults,
        clearResults: this.clearResults,
        getStaff: this.getStaff,
        getUsedInfo: this.getUsedInfo,
        closeComponent: this.closeComponent,
        setMulti: this.setMulti,
        getSearchInfo: this.getSearchInfo,
        addAllUsers: this.addAllUsers
      }, this.state, this.config, this.props)));
    }
  }]);

  return UserSelect;
}(Component);

export { UserSelect as default };