import styled, { css } from 'styled-components';
import { clickable } from '../../style';
var ModeSelector =
/*#__PURE__*/
styled.span(["display:", ";border:1px solid #E6E8EB;border-radius:3px;line-height:25px;margin-right:16px;.font-task-mode-simple,.font-task-mode-complete{line-height:30px;}"], function (props) {
  return props.show ? 'inline-block' : 'none';
});
var common =
/*#__PURE__*/
css(["color:#667580;background-color:#fff;"]);
var selected =
/*#__PURE__*/
css(["color:#106ECC;background-color:rgba(133,194,255,0.15);"]);
var borderRight =
/*#__PURE__*/
css(["border-right:1px solid #E6E8EB;"]);
var borderLeft =
/*#__PURE__*/
css(["border-left:1px solid #E6E8EB;"]);
var ModeIcon =
/*#__PURE__*/
styled.span(["", " display:inline-block;width:30px;height:30px;", " ", " ", " vertical-align:middle;text-align:center;font-size:12px;:hover{color:#106ECC;}"], clickable, function (props) {
  return props.selected ? selected : common;
}, function (props) {
  return props.borderRight ? borderRight : '';
}, function (props) {
  return props.borderLeft ? borderLeft : '';
});
export { ModeSelector, ModeIcon };