import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import { UserWrap, UserTitle, SearchWrap, UserPopWrap } from './style';
import Search from '@beisen/search';
import { searchData } from './defatultSetting';
import UserSelector from '../UserSelector';
import ClickOutSide from '@beisen-cmps/italent-click-outside';
import UserListWrap from './userList';

var ChargeUserSelector =
/*#__PURE__*/
function (_Component) {
  _inherits(ChargeUserSelector, _Component);

  function ChargeUserSelector() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ChargeUserSelector);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ChargeUserSelector)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      showUser: false
    };

    _this.showUserSelector = function () {
      !_this.state.showUser && _this.setState({
        showUser: true
      });
    };

    _this.hideUserPop = function () {
      _this.state.showUser && _this.setState({
        showUser: false
      });
    };

    _this.userSelectSubmitHandler = function (data) {
      _this.props.onSelectUser(data);

      _this.hideUserPop();
    };

    return _this;
  }

  _createClass(ChargeUserSelector, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          show = _this$props.show,
          userList = _this$props.userList,
          handleDeleteUser = _this$props.handleDeleteUser;
      var showUser = this.state.showUser;
      return React.createElement(UserWrap, {
        show: show
      }, React.createElement(UserTitle, null, " \u8D1F\u8D23\u4EBA "), React.createElement(SearchWrap, null, React.createElement(Search, _extends({}, searchData, {
        onClick: this.showUserSelector
      }))), React.createElement(ClickOutSide, {
        onClickOutside: this.hideUserPop
      }, showUser && React.createElement(UserPopWrap, null, React.createElement(UserSelector, {
        value: "",
        isUseInitial: false,
        onSure: this.userSelectSubmitHandler,
        onClose: this.hideUserPop,
        offset: {
          right: 0,
          top: 0
        }
      }))), React.createElement(UserListWrap, {
        data: userList,
        onDeleteUser: handleDeleteUser
      }));
    }
  }]);

  return ChargeUserSelector;
}(Component);

export { ChargeUserSelector as default };