import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import { UserList, UserItem, UserInfo, UserName, UserEmail, RemoveUser } from './style';
import Avatar from 'ux-feature-avatar';

var UserItemWrap =
/*#__PURE__*/
function (_Component) {
  _inherits(UserItemWrap, _Component);

  function UserItemWrap() {
    _classCallCheck(this, UserItemWrap);

    return _possibleConstructorReturn(this, _getPrototypeOf(UserItemWrap).apply(this, arguments));
  }

  _createClass(UserItemWrap, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          onDeleteUser = _this$props.onDeleteUser;
      var avatarConfig = {
        name: data.Name,
        avatar: {
          hasAvatar: data.UserAvatar.HasAvatar,
          img: data.UserAvatar.Original,
          //头像图片,
          color: data.UserAvatar.Color
        },
        size: 30
      };
      return React.createElement(UserItem, null, React.createElement(Avatar, avatarConfig), React.createElement(UserInfo, null, React.createElement(UserName, null, " ", data.Name, " "), React.createElement(UserEmail, null, " ", data.Email, " ")), React.createElement(RemoveUser, {
        className: "font-task-remove",
        onClick: function onClick() {
          onDeleteUser(data.Id);
        }
      }));
    }
  }]);

  return UserItemWrap;
}(Component);

var UserListWrap =
/*#__PURE__*/
function (_Component2) {
  _inherits(UserListWrap, _Component2);

  function UserListWrap() {
    _classCallCheck(this, UserListWrap);

    return _possibleConstructorReturn(this, _getPrototypeOf(UserListWrap).apply(this, arguments));
  }

  _createClass(UserListWrap, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          data = _this$props2.data,
          onDeleteUser = _this$props2.onDeleteUser;
      return React.createElement(UserList, null, data.map(function (user, k) {
        return React.createElement(UserItemWrap, {
          key: "user-item-".concat(k),
          data: user,
          onDeleteUser: onDeleteUser
        });
      }));
    }
  }]);

  return UserListWrap;
}(Component);

export { UserListWrap as default };