import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import { MultiWrap, MultiTitle, MultiOpt } from './style';

var MultiItem =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MultiItem, _React$Component);

  function MultiItem() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MultiItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MultiItem)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleClick = function () {
      _this.props.onClick(_this.props.data);
    };

    return _this;
  }

  _createClass(MultiItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          onClick = _this$props.onClick,
          data = _this$props.data;
      return React.createElement(MultiOpt, {
        selected: data.selected,
        onClick: this.handleClick
      }, data.title);
    }
  }]);

  return MultiItem;
}(React.Component);

var MultiSelector =
/*#__PURE__*/
function (_Component) {
  _inherits(MultiSelector, _Component);

  function MultiSelector() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, MultiSelector);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(MultiSelector)).call.apply(_getPrototypeOf3, [this].concat(args)));

    _this2.handleOptClick = function (v) {
      var data = _this2.props.data;

      _this2.props.onClick(data.key, v);
    };

    return _this2;
  }

  _createClass(MultiSelector, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          data = _this$props2.data,
          onClick = _this$props2.onClick;
      return React.createElement(MultiWrap, null, React.createElement(MultiTitle, null, data.title), data.value.map(function (v, k) {
        return React.createElement(MultiItem, {
          data: v,
          key: "multi-opt-".concat(k),
          onClick: _this3.handleOptClick
        });
      }));
    }
  }]);

  return MultiSelector;
}(Component);

export { MultiSelector as default };