import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import { OrderSelector, OrderText, OrderIcon, OrderCover } from './style';
import Pop from '../common/drop';
import ClickOutSide from '@beisen-cmps/italent-click-outside';
import ToolTip from '@beisen/tool-tip';

var OrderArea =
/*#__PURE__*/
function (_Component) {
  _inherits(OrderArea, _Component);

  function OrderArea() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, OrderArea);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(OrderArea)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      showPop: false
    };

    _this.showPop = function () {
      _this.setState({
        showPop: true
      });
    };

    _this.hidePop = function () {
      _this.setState({
        showPop: false
      });
    };

    _this.selectOrder = function (d) {
      _this.hidePop();

      _this.props.selectOrder(d);
    };

    _this.getDefault = function (isExpire) {
      if (isExpire) {
        return 4;
      }

      return 7;
    };

    return _this;
  }

  _createClass(OrderArea, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          data = _this$props.data,
          isExpire = _this$props.isExpire;
      var showPop = this.state.showPop;
      var selected = data.filter(function (d) {
        return d.selected;
      })[0] || data[0];
      return React.createElement(OrderSelector, {
        show: data && !!data.length
      }, React.createElement(OrderText, {
        selected: selected.id != this.getDefault(isExpire),
        onClick: this.showPop
      }, React.createElement(OrderIcon, {
        className: "font-task-order"
      }), "\u6392\u5E8F", React.createElement(ToolTip, {
        side: false,
        title: selected.title
      }, React.createElement(OrderCover, null))), React.createElement(ClickOutSide, {
        onClickOutside: this.hidePop
      }, React.createElement(Pop, {
        data: data,
        left: "0px",
        top: "40px",
        show: showPop,
        onClickPop: this.selectOrder
      })));
    }
  }]);

  return OrderArea;
}(Component);

export { OrderArea as default };